using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Sales.Invoice.Cqrs;

public record DeleteInvoiceByIdCommand(string Id) : IRequest<bool>;

public class DeleteInvoiceByIdHandler : IRequestHandler<DeleteInvoiceByIdCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteInvoiceByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteInvoiceByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.Invoice
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.Invoice.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);
        return true;
    }
}